#!/usr/bin/env python

import sys
import shlex
from connection import Connection
from handle import CommandHandler

if __name__ == '__main__':
    print 'Encrypted file system client'

    if len(sys.argv) == 2:
        host = sys.argv[1]
    else:
        print 'Usage: ./client.py host'
        sys.exit(0)

    print 'Connecting...'
    
    
    c = Connection(host)
    if not c.connect():
        print 'Could not connect.  Exiting...'
        sys.exit(0)

    cmd_handle = None
    print 'Reading identity...'
    try:
        id_f = open('idhome.txt', 'r')
        user_id = int(id_f.readline())
        home_id = int(id_f.readline())

        pub_k = open('pubKey.pem', 'r').read()
        priv_k = open('priKey.pem', 'r').read()

        c.set_key(user_id, priv_k)
        cmd_handle = CommandHandler(c, user_id, home_id, pub_k, priv_k)
        print 'Found.  Ready to go!'
    except IOError:
        print 'None found. Ready to go!'
        cmd_handle = CommandHandler(c)

    while True:
        try:
            cmd = raw_input(cmd_handle.working_directory_name + '$ ');
            if cmd.strip() == '':
                continue
            split_cmd = shlex.split(cmd)
            if 'cmd_' + split_cmd[0] in dir(cmd_handle):
                if split_cmd[0] != 'register' and cmd_handle.user_id is None:
                    print 'You need to register.  Type register'
                    continue
                result = getattr(cmd_handle, 'cmd_' + split_cmd[0])(split_cmd[1:])
                if not result:
                    print 'Exiting...'
                    break
            else:
                print 'Unknown command'
        except KeyboardInterrupt:
            break
        except ValueError:
            pass
            #print 'Broken command'
    c.close()
